%global srcname etcd3gw

%if 0%{?fedora} && 0%{?fedora} < 30
%bcond_without python2
%bcond_without python3
%else
%if 0%{?fedora} || 0%{?rhel} > 7
%bcond_with    python2
%bcond_without python3
%else
%bcond_without python2
%bcond_with    python3
%endif
%endif

Name:           python-%{srcname}
Version:        0.2.4
Release:        7%{?dist}
Summary:        An etcd3 gateway Python client

License:        ASL 2.0
URL:            https://pypi.python.org/pypi/%{srcname}
Source0:        %{pypi_source}

BuildArch:      noarch

%description
A python client for etcd3 grpc-gateway v3alpha API

%if %{with python2}
%package -n python2-%{srcname}
Summary:        %{summary}
BuildRequires:  python2-devel

BuildRequires:  python2-futurist
BuildRequires:  python2-oslotest
BuildRequires:  python2-requests

Requires:  python2-futurist
Requires:  python2-pbr
Requires:  python2-requests
Requires:  python2-six

%{?python_provide:%python_provide python2-%{srcname}}

%description -n python2-%{srcname}
A python client for etcd3 grpc-gateway v3alpha API
%endif

%if %{with python3}
%package -n python3-%{srcname}
Summary:        %{summary}
BuildRequires:  python3-devel

BuildRequires:  python3-futurist
BuildRequires:  python3-oslotest
BuildRequires:  python3-requests

Requires: python3-futurist
Requires: python3-pbr
Requires: python3-requests
Requires: python3-six

%{?python_enable_dependency_generator}

%{?python_provide:%python_provide python3-%{srcname}}

%description -n python3-%{srcname}
A python client for etcd3 grpc-gateway v3alpha API
%endif

%prep
%autosetup -n %{srcname}-%{version}

# Let's manage dependencies using rpm deps.
rm -f *requirements.txt

%build
%if %{with python2}
%py2_build
%endif

%if %{with python3}
%py3_build
%endif

%install
%if %{with python2}
%py2_install
%endif

%if %{with python3}
%py3_install
%endif

%check
%if %{with python2}
export PYTHON=%{__python2}
%{__python2} setup.py test
%endif

%if %{with python3}
export PYTHON=%{__python3}
# workaround for https://bugs.launchpad.net/testrepository/+bug/1229445
rm -rf .testrepository/times.dbm
%{__python3} setup.py test
%endif

%if %{with python2}
%files -n python2-%{srcname}
%license LICENSE
%doc README.md CONTRIBUTING.rst HACKING.rst
%{python2_sitelib}/%{srcname}-*.egg-info/
%{python2_sitelib}/%{srcname}/
%endif

%if %{with python3}
%files -n python3-%{srcname}
%license LICENSE
%doc README.md CONTRIBUTING.rst HACKING.rst
%{python3_sitelib}/%{srcname}-*.egg-info/
%{python3_sitelib}/%{srcname}/
%endif


%changelog
* Fri Mar  8 2019 John Eckersberg <eck@redhat.com> - 0.2.4-7
- Before f30, build for both py2 and py3
- Add test workaround when run for both py2 and py3

* Tue Mar  5 2019 John Eckersberg <eck@redhat.com> - 0.2.4-6
- Add missing req for python3-pbr

* Tue Mar 05 2019 Eric Harney <eharney@redhat.com> - 0.2.4-5
- Add missing reqs for python3

* Mon Mar 04 2019 Eric Harney <eharney@redhat.com> - 0.2.4-4
- Remove runtime req on oslotest

* Thu Feb 28 2019 Alfredo Moralejo <amoralej@redhat.com> - 0.2.4-3
- Remve {test-,}requirements.txt to manage dependencies manually.

* Wed Feb 13 2019 John Eckersberg <eck@redhat.com> - 0.2.4-1
- Initial package

